;;; PRNTLESS.SCM   Code for 6.001 Spring 95
;;; Alternative Printing Control Procedure Definitions

(define (print-this-step? n body) #t)

(define (print-this-step? n body) #f)
            
(define (print-this-step? n body)        ;print at the rate 1/30
  (zero? (modulo n 500)))

(define (print-this-step? n body)        ;print at decreasing rate
  (or (zero? n)
      (let ((sqn (round (sqrt n))))
	(zero? (modulo n sqn)))))

(define print-stepped-message           ;print concise version 80% of the time
  (let ((count -1))
    (lambda (step-number body)
      (set! count (modulo (inc count) 5))
      (newline)
      (newline)
      (display ";==(")
      (display step-number)
      (display ")==>")
      (if (zero? count)
          (pp body)
          (pp (last-pair body))))))

(define print-stepped-message           ;print concise version
    (lambda (step-number body)
      (newline)
      (newline)
      (display ";==(")
      (display step-number)
      (display ")==>")
      (pp (last-pair body))))

